""" This file contains the operator to activate the face2Face addon"""
import bpy


class projectionsPropertiesGroup(bpy.types.PropertyGroup):
    projection_name: bpy.props.StringProperty()

    scale_variation_strength: bpy.props.FloatProperty(
        name="scale_variation_strength", description="scale_variation_strength", default=0)
    scale_relative_strength: bpy.props.FloatProperty(
        name="scale_relative_strength", description="scale_relative_strength", default=0)

    rotation_variation_strength: bpy.props.FloatProperty(
        name="rotation_variation_strength", description="rotation_variation_strength", default=0)


# TODO change to scene or so?

class OBJECT_OT_Face2FaceActivation(bpy.types.Operator):
    bl_label = "Activate face2Face addon"
    bl_description = "activate face2Face addon and init props"
    bl_idname = "object.activate_face2face"

    def init_props(self):
        # target _props
        bpy.types.Object.projections = bpy.props.CollectionProperty(
            type=projectionsPropertiesGroup)

        # source props
        bpy.types.Object.belongs_to = bpy.props.StringProperty(
            default="NOTHING")

        bpy.types.Object.matrix_local_bv = bpy.props.FloatVectorProperty(
            name="Matrix",
            size=16,
            subtype="MATRIX")
        bpy.types.Object.inner_mesh_rot = bpy.props.FloatVectorProperty(
            name="Matrix",
            size=9,
            subtype="MATRIX")

        bpy.types.Object.matrix_local_org = bpy.props.FloatVectorProperty(
            name="Matrix",
            size=16,
            subtype="MATRIX")
        bpy.types.Object.matrix_local_startorg = bpy.props.FloatVectorProperty(
            name="Matrix",
            size=16,
            subtype="MATRIX")
        bpy.types.Object.matrix_custom_transform = bpy.props.FloatVectorProperty(
            name="Matrix",
            size=9,
            subtype="MATRIX")
        bpy.types.Object.scaling_center = bpy.props.FloatVectorProperty(
            name="scaling_center", description="scaling center", size=3)
        bpy.types.Object.scaling_vary = bpy.props.FloatProperty(
            name="scaling_vary", description="scaling_vary", default=1)
        bpy.types.Object.scaling_vary_org = bpy.props.FloatProperty(
            name="scaling_vary_org", description="scaling_vary_org", default=1)
        bpy.types.Object.scaling = bpy.props.FloatVectorProperty(
            name="scaling", description="scaling", size=3,  default=(1, 1, 1))
        bpy.types.Object.scaling_org = bpy.props.FloatVectorProperty(
            name="scaling_org", description="scaling_org", size=3,  default=(1, 1, 1))
        bpy.types.Object.scaling_startorg = bpy.props.FloatVectorProperty(
            name="scaling_startorg", description="scaling_startorg", size=3,  default=(1, 1, 1))

        bpy.types.Object.rotation_vary = bpy.props.FloatProperty(
            name="rotation_vary", description="rotation_vary", default=0)
        bpy.types.Object.rotation_vary_org = bpy.props.FloatProperty(
            name="rotation_vary_org", description="rotation_vary_org", default=0)
        bpy.types.Object.rotation = bpy.props.FloatProperty(
            name="rotation", description="rotation",   default=0)
        bpy.types.Object.rotation_org = bpy.props.FloatProperty(
            name="rotation_org", description="rotation_org",   default=0)
        bpy.types.Object.rotation_flipped = bpy.props.BoolProperty(
            name="rotation_flipped", description="rotation_flipped", default=False)
        # bpy.types.Object.scaling_vary = bpy.props.FloatProperty(
        #    name="scaling", description="scaling", default=1)
        bpy.types.Object.scaling_vary_applied = bpy.props.BoolProperty(
            name="scaling_vary_applied", description="scaling_vary_applied", default=False)
        bpy.types.Object.target_face_index = bpy.props.IntProperty(
            name="target_face_index", description="target face index", default=-1)
        bpy.types.Object.source_face_index = bpy.props.IntProperty(
            name="source_face_index", description="source face index", default=-1)
        bpy.types.Object.aligned_edge_index = bpy.props.IntProperty(
            name="aligned_edge_index", description="aligned_edge_index", default=0)
        bpy.types.Object.tf_aligned_edge_index = bpy.props.IntProperty(
            name="tf_aligned_edge_index", description="tf_aligned_edge_index", default=0)
        bpy.types.Object.object_type = bpy.props.IntProperty(
            name="object_type", description="object_type", default=0)

    def execute(self, context):
        context.window_manager.face2face.is_active = True
        self.init_props()
        #print("Activated face2FACE addon")
        return {'FINISHED'}


def register():
    bpy.utils.register_class(projectionsPropertiesGroup)
    bpy.utils.register_class(OBJECT_OT_Face2FaceActivation)


def unregister():
    bpy.utils.unregister_class(projectionsPropertiesGroup)
    bpy.utils.unregister_class(OBJECT_OT_Face2FaceActivation)
