import bpy

# Import From Files
""" if "bpy" in locals():
    import importlib
    #from .. import helpers
    #importlib.reload(helpers)
    #from ..helpers import addon_prefs
else:
    #from ..helpers import addon_prefs """

STATUS_TEXT_HEADER_COLOR_DEFAULT = (1.0, 0.876, 0.320, 0.75)
STATUS_TEXT_COLOR_DEFAULT = (0.963, .955, 1.0, 0.75)
#STATUS_TEXT_COLOR_ERROR = (0.9, 0.02, 0.0, 0.75)
STATUS_TEXT_COLOR_ERROR = (1, 0.120779, 0.017737, 0.75)
HIGLIGHT_PROJECTED_OBJECT_COLOR = (0.27, 0.56, 0.69)  # , 0.75)
HIGLIGHT_ROTATION_FLIPPED_COLOR = (0.79, 0.026, 0.019)

current_projection_name = "NOTHING"


class ColorProps():
    # TODO color chooser for highlight
    status_text_header_color: bpy.props.FloatVectorProperty(
        name="Header text",
        subtype="COLOR",
        size=4,
        min=0.0,
        max=1.0,
        default=STATUS_TEXT_HEADER_COLOR_DEFAULT
    )
    status_text_color: bpy.props.FloatVectorProperty(
        name="Status text",
        subtype="COLOR",
        size=4,
        min=0.0,
        max=1.0,
        default=STATUS_TEXT_COLOR_DEFAULT
    )
    status_text_error_color: bpy.props.FloatVectorProperty(
        name="Error text",
        subtype="COLOR",
        size=4,
        min=0.0,
        max=1.0,
        default=STATUS_TEXT_COLOR_ERROR
    )
    highlight_projected_objects_color: bpy.props.FloatVectorProperty(
        name="Projected objects",
        subtype="COLOR",
        size=3,
        min=0.0,
        max=1.0,
        default=HIGLIGHT_PROJECTED_OBJECT_COLOR
    )
    highlight_rotation_flipped_color: bpy.props.FloatVectorProperty(
        name="Rrotation flipped",
        subtype="COLOR",
        size=3,
        min=0.0,
        max=1.0,
        default=HIGLIGHT_ROTATION_FLIPPED_COLOR
    )

    def draw_colors(self, context, layout, header_text):
        # color theme
        box_outer = layout.box()
        col = box_outer.column()
        col.label(text=header_text)
        box_inner = box_outer.box()
        col = box_inner.row(align=True)
        col.label(text="---- Text colors ----")
        col = box_inner.row(align=True)
        col.prop(self, "status_text_header_color", expand=False)
        col = box_inner.row(align=True)
        col.prop(self, "status_text_color", expand=False)
        col = box_inner.row(align=True)
        col.prop(self, "status_text_error_color", expand=False)
        # if context.window_manager.face2face.highlight_projected_objects:
        if self.highlight_projected_objects or self.highlight_rotation_flipped:
            box_high = box_outer.box()
            col = box_high.row(align=True)
            col.label(text="--- Highlight colors ---")
            if self.highlight_projected_objects:
                col = box_high.row(align=False)
                col.prop(self, "highlight_projected_objects_color", expand=False)
            if self.highlight_rotation_flipped:
                col = box_high.row(align=True)
                col.prop(self, "highlight_rotation_flipped_color", expand=False)
