""" This file contains the operator to activate the face2Face addon"""
import bpy


class OBJECT_OT_Face2FaceProjectionReactivation(bpy.types.Operator):
    bl_label = "Reactivate face2Face projection"
    bl_description = "Reactivate a face2Face projection by its name"
    bl_idname = "object.reactivate_face2face_projection"

    reactivation_name: bpy.props.StringProperty(name='reactivation_name',
                                                default="NO_NAME")

    def execute(self, context):
        # print("reactivating face2Face projection:" +
        #      self.reactivation_name+"... -->")
        bpy.ops.object.face2face(
            execute_mode='REACTIVATION', reactivation_name=self.reactivation_name)
        # print("reactivated face2Face projection:" +
        #      self.reactivation_name+"... <--")
        return {'FINISHED'}


def register():
    bpy.utils.register_class(OBJECT_OT_Face2FaceProjectionReactivation)


def unregister():
    bpy.utils.unregister_class(OBJECT_OT_Face2FaceProjectionReactivation)
