import bpy

# Import From Files
if "bpy" in locals():
    import importlib
    from . import options_panel
    importlib.reload(options_panel)
    from . import projection_panel
    importlib.reload(projection_panel)
    from . import functional_settings_panel
    importlib.reload(functional_settings_panel)
    from . import usability_settings_panel
    importlib.reload(usability_settings_panel)
    from . import visual_settings_panel
    importlib.reload(visual_settings_panel)
else:
    from . import options_panel
    from . import projection_panel
    from . import functional_settings_panel
    from . import usability_settings_panel
    from . import visual_settings_panel


def register():
    projection_panel.register()
    options_panel.register()
    functional_settings_panel.register()
    usability_settings_panel.register()
    visual_settings_panel.register()
    # bpy.types.VIEW3D_MT_editor_menus.append(options_panel.popover)


def unregister():
    projection_panel.unregister()
    options_panel.unregister()
    functional_settings_panel.unregister()
    usability_settings_panel.unregister()
    visual_settings_panel.unregister()
    # bpy.types.VIEW3D_MT_editor_menus.remove(options_panel.popover)
